/**
 * @license
 *-------------------------------------------------------------------------------------------
 * Copyright © 2025 Progress Software Corporation. All rights reserved.
 * Licensed under commercial license. See LICENSE.md in the package root for more information
 *-------------------------------------------------------------------------------------------
 */
"use strict";Object.defineProperty(exports,Symbol.toStringTag,{value:"Module"});const e=require("../messages/index.js"),a=require("@progress/kendo-svg-icons"),l=require("@progress/kendo-editor-common"),i={...l.indentRules.listsTypes};exports.EditorToolsSettings=void 0;(n=>{const s={type:"button"};n.bold={...l.bold,props:{icon:"bold",svgIcon:a.boldIcon,...s},messages:{title:e.keys.bold},commandName:"Bold"},n.italic={...l.italic,props:{icon:"italic",svgIcon:a.italicIcon,...s},messages:{title:e.keys.italic},commandName:"Italic"},n.underline={...l.underline,props:{icon:"underline",svgIcon:a.underlineIcon,...s},messages:{title:e.keys.underline},commandName:"Underline"},n.strikethrough={...l.strikethrough,props:{icon:"strikethrough",svgIcon:a.strikethroughIcon,...s},messages:{title:e.keys.strikethrough},commandName:"Strikethrough"},n.subscript={...l.subscript,props:{icon:"subscript",svgIcon:a.subscriptIcon,...s},messages:{title:e.keys.subscript},commandName:"Subscript"},n.superscript={...l.superscript,props:{icon:"supscript",svgIcon:a.supscriptIcon,...s},messages:{title:e.keys.superscript},commandName:"Superscript"},n.link={...l.link,props:{icon:"link",svgIcon:a.linkIcon,...s},messages:{insertHyperlink:e.keys.insertHyperlink,insertHyperlinkDialogTitle:e.keys.insertHyperlinkDialogTitle,insertHyperlinkAddress:e.keys.insertHyperlinkAddress,insertHyperlinkTitle:e.keys.insertHyperlinkTitle,insertHyperlinkNewWindow:e.keys.insertHyperlinkNewWindow,insertHyperlinkCancel:e.keys.insertHyperlinkCancel,insertHyperlinkInsert:e.keys.insertHyperlinkInsert},commandName:"Link"},n.insertFile={...l.link,props:{icon:"file-add",svgIcon:a.fileAddIcon,...s},messages:{insertHyperlink:e.keys.insertFile,insertHyperlinkDialogTitle:e.keys.insertFileDialogTitle,insertHyperlinkAddress:e.keys.insertFileAddress,insertHyperlinkTitle:e.keys.insertFileTitle,insertHyperlinkNewWindow:"",insertHyperlinkCancel:e.keys.insertFileCancel,insertHyperlinkInsert:e.keys.insertFileInsert},commandName:"InsertFile",linkTarget:!1},n.insertTable={props:{icon:"table-add",svgIcon:a.tableAddIcon,...s},messages:{createTable:e.keys.createTable,createTableHint:e.keys.createTableHint},commandName:"InsertTable"},n.addRowBefore={props:{icon:"table-row-insert-above",svgIcon:a.tableRowInsertAboveIcon,...s},messages:{title:e.keys.addRowBefore},commandName:"AddRowBefore"},n.addRowAfter={props:{icon:"table-row-insert-below",svgIcon:a.tableRowInsertBelowIcon,...s},messages:{title:e.keys.addRowAfter},commandName:"AddRowAfter"},n.addColumnBefore={props:{icon:"table-column-insert-left",svgIcon:a.tableColumnInsertLeftIcon,...s},messages:{title:e.keys.addColumnBefore},commandName:"AddColumnBefore"},n.addColumnAfter={props:{icon:"table-column-insert-right",svgIcon:a.tableColumnInsertRightIcon,...s},messages:{title:e.keys.addColumnAfter},commandName:"AddColumnAfter"},n.deleteRow={props:{icon:"table-row-delete",svgIcon:a.tableRowDeleteIcon,...s},messages:{title:e.keys.deleteRow},commandName:"DeleteRow"},n.deleteColumn={props:{icon:"table-column-delete",svgIcon:a.tableColumnDeleteIcon,...s},messages:{title:e.keys.deleteColumn},commandName:"DeleteColumn"},n.deleteTable={props:{icon:"table-delete",svgIcon:a.tableDeleteIcon,...s},messages:{title:e.keys.deleteTable},commandName:"DeleteTable"},n.mergeCells={props:{icon:"cells-merge",svgIcon:a.cellsMergeIcon,...s},messages:{title:e.keys.mergeCells},commandName:"MergeCells"},n.splitCell={props:{icon:"cell-split-horizontally",svgIcon:a.cellSplitHorizontallyIcon,...s},messages:{title:e.keys.splitCell},commandName:"SplitCell"},n.print={props:{icon:"print",svgIcon:a.printIcon,...s},messages:{title:e.keys.print}},n.selectAll={props:{icon:"select-all",svgIcon:a.selectAllIcon,...s},messages:{title:e.keys.selectAll}},n.pdf={props:{icon:"file-pdf",svgIcon:a.filePdfIcon,...s},messages:{title:e.keys.pdf}},n.savePdfOptions={fileName:"editor.pdf",paperSize:"A4",margin:"1cm"},n.cleanFormatting={props:{icon:"clear-css",svgIcon:a.clearCssIcon,...s},messages:{title:e.keys.cleanFormatting},commandName:"CleanFormatting"},n.image={node:"image",props:{icon:"image",svgIcon:a.imageIcon,...s},messages:{insertImage:e.keys.insertImage,insertImageDialogTitle:e.keys.insertImageDialogTitle,insertImageAddress:e.keys.insertImageAddress,insertImageTitle:e.keys.insertImageTitle,insertImageAltText:e.keys.insertImageAltText,insertImageWidth:e.keys.insertImageWidth,insertImageHeight:e.keys.insertImageHeight,insertImageCancel:e.keys.insertImageCancel,insertImageInsert:e.keys.insertImageInsert},commandName:"InsertImage"},n.viewHtml={props:{icon:"code",svgIcon:a.codeIcon,...s},messages:{viewHtml:e.keys.viewHtml,viewHtmlDialogTitle:e.keys.viewHtmlDialogTitle,viewHtmlCancel:e.keys.viewHtmlCancel,viewHtmlUpdate:e.keys.viewHtmlUpdate},commandName:"SetContent"},n.findAndReplace={props:{icon:"find",svgIcon:a.binocularsIcon,...s},messages:{findReplaceToolTitle:e.keys.findReplaceToolTitle,findReplaceDialogTitle:e.keys.findReplaceDialogTitle,findReplaceTabFind:e.keys.findReplaceTabFind,findReplaceTabReplace:e.keys.findReplaceTabReplace,findReplaceFindWhat:e.keys.findReplaceFindWhat,findReplaceReplaceWith:e.keys.findReplaceReplaceWith,findReplaceReplace:e.keys.findReplaceReplace,findReplaceReplaceAll:e.keys.findReplaceReplaceAll,findReplaceMatchCase:e.keys.findReplaceMatchCase,findReplaceMatchWord:e.keys.findReplaceMatchWord,findReplaceMatchCyclic:e.keys.findReplaceMatchCyclic,findReplaceUseRegExp:e.keys.findReplaceUseRegExp,findReplacePrevMatch:e.keys.findReplacePrevMatch,findReplaceNextMatch:e.keys.findReplaceNextMatch,findReplaceMatches:e.keys.findReplaceMatches,findReplaceInvalidRegExp:e.keys.findReplaceInvalidRegExp}},n.unlink={...l.link,props:{icon:"unlink",svgIcon:a.unlinkIcon,...s},messages:{title:e.keys.unlink},commandName:"Unlink"},n.undo={props:{icon:"undo",svgIcon:a.undoIcon,...s},messages:{title:e.keys.undo},commandName:"Undo"},n.redo={props:{icon:"redo",svgIcon:a.redoIcon,...s},messages:{title:e.keys.redo},commandName:"Redo"},n.fontSize={style:"font-size",defaultItem:{text:e.messages[e.keys.fontSize],value:"",localizationKey:e.keys.fontSize},items:[{text:"1 (8pt)",value:"xx-small"},{text:"2 (10pt)",value:"x-small"},{text:"3 (12pt)",value:"small"},{text:"4 (14pt)",value:"medium"},{text:"5 (18pt)",value:"large"},{text:"6 (24pt)",value:"x-large"},{text:"7 (36pt)",value:"xx-large"}],commandName:"FontSize"},n.fontName={style:"font-family",defaultItem:{text:e.messages[e.keys.fontName],value:"",localizationKey:e.keys.fontName},items:[{text:"Arial",value:"Arial, Helvetica, sans-serif",style:{fontFamily:"Arial, Helvetica, sans-serif"}},{text:"Courier New",value:"'Courier New', Courier, monospace",style:{fontFamily:"'Courier New', Courier, monospace"}},{text:"Georgia",value:"Georgia, serif",style:{fontFamily:"Georgia, serif"}},{text:"Impact",value:"Impact, Charcoal, sans-serif",style:{fontFamily:"Impact, Charcoal, sans-serif"}},{text:"Lucida Console",value:"'Lucida Console', Monaco, monospace",style:{fontFamily:"'Lucida Console', Monaco, monospace"}},{text:"Tahoma",value:"Tahoma, Geneva, sans-serif",style:{fontFamily:"Tahoma, Geneva, sans-serif"}},{text:"Times New Roman",value:"'Times New Roman', Times,serif",style:{fontFamily:"'Times New Roman', Times,serif"}},{text:"Trebuchet MS",value:"'Trebuchet MS', Helvetica, sans-serif",style:{fontFamily:"'Trebuchet MS', Helvetica, sans-serif"}},{text:"Verdana",value:"Verdana, Geneva, sans-serif",style:{fontFamily:"Verdana, Geneva, sans-serif"}}],commandName:"FontName"},n.formatBlock={defaultItem:{text:e.messages[e.keys.format],value:"",localizationKey:e.keys.format},items:[{text:"Paragraph",value:"p",style:{display:"block",marginLeft:0}},{text:"Heading 1",value:"h1",style:{display:"block",fontSize:"2em",marginLeft:0,fontWeight:"bold"}},{text:"Heading 2",value:"h2",style:{display:"block",fontSize:"1.5em",marginLeft:0,fontWeight:"bold"}},{text:"Heading 3",value:"h3",style:{display:"block",fontSize:"1.17em",marginLeft:0,fontWeight:"bold"}},{text:"Heading 4",value:"h4",style:{display:"block",fontSize:"1em",marginLeft:0,fontWeight:"bold"}},{text:"Heading 5",value:"h5",style:{display:"block",fontSize:"0.83em",marginLeft:0,fontWeight:"bold"}},{text:"Heading 6",value:"h6",style:{display:"block",fontSize:"0.67em",marginLeft:0,fontWeight:"bold"}}],commandName:"FormatBlock"},n.foreColor={style:"color",colorPickerProps:{icon:"foreground-color",svgIcon:a.foregroundColorIcon,view:"palette",title:e.keys.foregroundColor,ariaLabel:e.keys.foreColorLabel},commandName:"ForeColor"},n.backColor={style:"background-color",colorPickerProps:{icon:"droplet",svgIcon:a.dropletIcon,view:"palette",title:e.keys.backgroundColor,ariaLabel:e.keys.backColorLabel},commandName:"BackColor"},n.alignLeft={actions:[...l.alignLeftRules],props:{icon:"align-left",svgIcon:a.alignLeftIcon,...s},messages:{title:e.keys.alignLeft},commandName:"AlignLeft"},n.alignRight={actions:[...l.alignRightRules],props:{icon:"align-right",svgIcon:a.alignRightIcon,...s},messages:{title:e.keys.alignRight},commandName:"AlignRight"},n.alignCenter={actions:[...l.alignCenterRules],props:{icon:"align-center",svgIcon:a.alignCenterIcon,...s},messages:{title:e.keys.alignCenter},commandName:"AlignCenter"},n.alignJustify={actions:[...l.alignJustifyRules],props:{icon:"align-justify",svgIcon:a.alignJustifyIcon,...s},messages:{title:e.keys.alignJustify},commandName:"AlignJustify"},n.alignRemove={actions:[...l.alignRemoveRules],props:{icon:"align-remove",svgIcon:a.alignRemoveIcon,...s},messages:{},commandName:"AlignRemove"},n.indent={actions:l.indentRules.nodes,listsTypes:i,props:{icon:"indent",svgIcon:a.indentIcon,...s},messages:{title:e.keys.indent},commandName:"Indent"},n.outdent={actions:l.outdentRules.nodes,listsTypes:i,props:{icon:"outdent",svgIcon:a.outdentIcon,...s},messages:{title:e.keys.outdent},commandName:"Outdent"},n.orderedList={listType:i.orderedList,props:{icon:"list-ordered",svgIcon:a.listOrderedIcon,...s},messages:{title:e.keys.orderedList},commandName:"OrderedList",types:{...i}},n.bulletList={listType:i.bulletList,props:{icon:"list-unordered",svgIcon:a.listUnorderedIcon,...s},messages:{title:e.keys.bulletList},commandName:"UnorderedList",types:{...i}}})(exports.EditorToolsSettings||(exports.EditorToolsSettings={}));exports.listsTypes=i;
