/**
 * @license
 *-------------------------------------------------------------------------------------------
 * Copyright © 2025 Progress Software Corporation. All rights reserved.
 * Licensed under commercial license. See LICENSE.md in the package root for more information
 *-------------------------------------------------------------------------------------------
 */
"use client";
"use strict";Object.defineProperty(exports,Symbol.toStringTag,{value:"Module"});const t=require("./Editor.js"),o=require("./tools/index.js"),l=require("./config/toolsSettings.js"),r=require("./utils/index.js"),n=require("./dialogs/index.js"),i=require("./utils/props-key.js"),e=require("@progress/kendo-editor-common"),a={Selection:e.Selection,SelectionRange:e.SelectionRange,TextSelection:e.TextSelection,NodeSelection:e.NodeSelection,AllSelection:e.AllSelection,EditorState:e.EditorState,Plugin:e.Plugin,PluginKey:e.PluginKey,Transaction:e.Transaction,Decoration:e.Decoration,DecorationSet:e.DecorationSet,EditorView:e.EditorView,Node:e.Node,ResolvedPos:e.ResolvedPos,NodeRange:e.NodeRange,Fragment:e.Fragment,Slice:e.Slice,ReplaceError:e.ReplaceError,Mark:e.Mark,Schema:e.Schema,NodeType:e.NodeType,MarkType:e.MarkType,ContentMatch:e.ContentMatch,DOMParser:e.DOMParser,DOMSerializer:e.DOMSerializer,Transform:e.Transform,Step:e.Step,StepResult:e.StepResult,joinPoint:e.joinPoint,canJoin:e.canJoin,canSplit:e.canSplit,insertPoint:e.insertPoint,dropPoint:e.dropPoint,liftTarget:e.liftTarget,findWrapping:e.findWrapping,StepMap:e.StepMap,MapResult:e.MapResult,Mapping:e.Mapping,AddMarkStep:e.AddMarkStep,RemoveMarkStep:e.RemoveMarkStep,ReplaceStep:e.ReplaceStep,ReplaceAroundStep:e.ReplaceAroundStep,replaceStep:e.replaceStep,deleteSelection:e.deleteSelection,joinBackward:e.joinBackward,selectNodeBackward:e.selectNodeBackward,joinForward:e.joinForward,selectNodeForward:e.selectNodeForward,joinUp:e.joinUp,joinDown:e.joinDown,lift:e.lift,newlineInCode:e.newlineInCode,exitCode:e.exitCode,createParagraphNear:e.createParagraphNear,liftEmptyBlock:e.liftEmptyBlock,splitBlock:e.splitBlock,splitBlockKeepMarks:e.splitBlockKeepMarks,selectParentNode:e.selectParentNode,selectAll:e.selectAll,wrapIn:e.wrapIn,setBlockType:e.setBlockType,toggleMark:e.toggleMark,autoJoin:e.autoJoin,chainCommands:e.chainCommands,pcBaseKeymap:e.pcBaseKeymap,macBaseKeymap:e.macBaseKeymap,baseKeymap:e.baseKeymap,history:e.history,undo:e.undo,redo:e.redo,undoDepth:e.undoDepth,redoDepth:e.redoDepth,InputRule:e.InputRule,inputRules:e.inputRules,undoInputRule:e.undoInputRule,emDash:e.emDash,ellipsis:e.ellipsis,openDoubleQuote:e.openDoubleQuote,closeDoubleQuote:e.closeDoubleQuote,openSingleQuote:e.openSingleQuote,closeSingleQuote:e.closeSingleQuote,smartQuotes:e.smartQuotes,wrappingInputRule:e.wrappingInputRule,textblockTypeInputRule:e.textblockTypeInputRule,keymap:e.keymap,keydownHandler:e.keydownHandler,orderedList:e.orderedList,bulletList:e.bulletList,listItem:e.listItem,addListNodes:e.addListNodes,wrapInList:e.wrapInList,splitListItem:e.splitListItem,liftListItem:e.liftListItem,sinkListItem:e.sinkListItem,dropCursor:e.dropCursor,gapCursor:e.gapCursor,tableEditing:e.tableEditing,fixTables:e.fixTables,fixTablesKey:e.fixTablesKey,cellAround:e.cellAround,isInTable:e.isInTable,selectionCell:e.selectionCell,moveCellForward:e.moveCellForward,inSameTable:e.inSameTable,findCell:e.findCell,colCount:e.colCount,nextCell:e.nextCell,removeColSpan:e.removeColSpan,addColSpan:e.addColSpan,columnIsHeader:e.columnIsHeader,tableNodes:e.tableNodes,tableNodeTypes:e.tableNodeTypes,CellSelection:e.CellSelection,TableMap:e.TableMap,tableEditingKey:e.tableEditingKey,columnResizing:e.columnResizing,columnResizingPluginKey:e.columnResizingPluginKey,updateColumnsOnResize:e.updateColumnsOnResize,selectedRect:e.selectedRect,addColumn:e.addColumn,addColumnBefore:e.addColumnBefore,addColumnAfter:e.addColumnAfter,deleteColumn:e.deleteColumn,rowIsHeader:e.rowIsHeader,addRow:e.addRow,addRowBefore:e.addRowBefore,addRowAfter:e.addRowAfter,deleteRow:e.deleteRow,mergeCells:e.mergeCells,splitCell:e.splitCell,splitCellWithType:e.splitCellWithType,setCellAttr:e.setCellAttr,toggleHeader:e.toggleHeader,toggleHeaderRow:e.toggleHeaderRow,toggleHeaderColumn:e.toggleHeaderColumn,toggleHeaderCell:e.toggleHeaderCell,goToNextCell:e.goToNextCell,deleteTable:e.deleteTable};exports.Editor=t.Editor;Object.defineProperty(exports,"EditorTools",{enumerable:!0,get:()=>o.EditorTools});Object.defineProperty(exports,"EditorToolsSettings",{enumerable:!0,get:()=>l.EditorToolsSettings});Object.defineProperty(exports,"EditorUtils",{enumerable:!0,get:()=>r.EditorUtils});Object.defineProperty(exports,"EditorDialogs",{enumerable:!0,get:()=>n.EditorDialogs});exports.editorPropsKey=i.editorPropsKey;Object.defineProperty(exports,"getHtml",{enumerable:!0,get:()=>e.getHtml});Object.defineProperty(exports,"marks",{enumerable:!0,get:()=>e.marks});Object.defineProperty(exports,"nodes",{enumerable:!0,get:()=>e.nodes});Object.defineProperty(exports,"parseContent",{enumerable:!0,get:()=>e.parseContent});exports.ProseMirror=a;
