/**
 * @license
 *-------------------------------------------------------------------------------------------
 * Copyright © 2025 Progress Software Corporation. All rights reserved.
 * Licensed under commercial license. See LICENSE.md in the package root for more information
 *-------------------------------------------------------------------------------------------
 */
"use strict";Object.defineProperty(exports,Symbol.toStringTag,{value:"Module"});const e="editor.bold",t="editor.italic",o="editor.underline",r="editor.strikethrough",i="editor.subscript",l="editor.superscript",s="editor.hyperlink",n="editor.insertFile",d="editor.print",c="editor.selectAll",a="editor.cleanFormatting",p="editor.pdf",b="editor.foregroundColor",P="editor.backgroundColor",g="editor.createTable",C="editor.insertTableHint",h="editor.addRowBefore",m="editor.addRowAfter",f="editor.addColumnBefore",R="editor.addColumnAfter",u="editor.deleteRow",A="editor.deleteColumn",y="editor.deleteTable",T="editor.mergeCells",S="editor.splitCell",B="editor.hyperlink-dialog-title",I="editor.hyperlink-dialog-content-address",w="editor.hyperlink-dialog-content-title",H="editor.hyperlink-dialog-content-newwindow",k="editor.hyperlink-dialog-cancel",v="editor.hyperlink-dialog-insert",W="editor.insertfile-dialog-title",L="editor.insertfile-dialog-content-address",F="editor.insertfile-dialog-content-title",M="editor.insertfile-dialog-cancel",x="editor.insertfile-dialog-insert",D="editor.image",N="editor.image-dialog-title",U="editor.image-address",E="editor.image-title",G="editor.image-altText",O="editor.image-width",z="editor.image-height",J="editor.image-cancel",V="editor.image-insert",j="editor.viewHtml",q="editor.viewHtml-dialog-title",K="editor.viewHtml-cancel",Q="editor.viewHtml-update",X="editor.unlink",Y="editor.undo",Z="editor.redo",_="editor.fontSize",$="editor.fontName",ee="editor.format",te="editor.alignLeft",oe="editor.alignRight",re="editor.alignCenter",ie="editor.alignJustify",le="editor.indent",se="editor.outdent",ne="editor.orderedList",de="editor.bulletList",ce="editor.findReplace-tool-title",ae="editor.findReplace-dialog-title",pe="editor.findReplace-tab-find",be="editor.findReplace-tab-replace",Pe="editor.findReplace-findWhat",ge="editor.findReplace-replaceWith",Ce="editor.findReplace-replace",he="editor.findReplace-replaceAll",me="editor.findReplace-matchCase",fe="editor.findReplace-matchWord",Re="editor.findReplace-matchCyclic",ue="editor.findReplace-useRegExp",Ae="editor.findReplace-prevMatch",ye="editor.findReplace-nextMatch",Te="editor.findReplace-matches",Se="editor.findReplace-invalidRegExp",Be="editor.iframeTitle",Ie="editorTools.foreColorLabel",we="editorTools.backColorLabel",He="editor.cellProperties",ke="editor.cellPropertiesLeftTop",ve="editor.cellPropertiesCenterTop",We="editor.cellPropertiesRightTop",Le="editor.cellPropertiesLeftMiddle",Fe="editor.cellPropertiesCenterMiddle",Me="editor.cellPropertiesRightMiddle",xe="editor.cellPropertiesLeftBottom",De="editor.cellPropertiesCenterBottom",Ne="editor.cellPropertiesRightBottom",Ue="editor.cellPropertiesNoAlignment",Ee="editor.cellPropertiesWrap",Ge="editor.cellPropertiesFitToCell",Oe="editor.cellPropertiesApplyToAllCells",ze="editor.cellPropertiesWidth",Je="editor.cellPropertiesApplyToColumn",Ve="editor.cellPropertiesHeight",je="editor.cellPropertiesApplyToRow",qe="editor.cellPropertiesAlignment",Ke="editor.cellPropertiesTextControl",Qe="editor.cellPropertiesCellPadding",Xe="editor.cellPropertiesBackground",Ye="editor.cellPropertiesBorderWidth",Ze="editor.cellPropertiesBorderColor",_e="editor.cellPropertiesBorderStyle",$e="editor.cellPropertiesId",et="editor.cellPropertiesCssClass",tt="editor.cellPropertiesSave",ot="editor.cellPropertiesCancel",rt="editor.tableProperties",it="editor.tablePropertiesAlignLeft",lt="editor.tablePropertiesAlignCenter",st="editor.tablePropertiesAlignRight",nt="editor.tablePropertiesNoAlignment",dt="editor.tablePropertiesLeft",ct="editor.tablePropertiesCenter",at="editor.tablePropertiesRight",pt="editor.tablePropertiesTop",bt="editor.tablePropertiesBottom",Pt="editor.tablePropertiesNone",gt="editor.tablePropertiesUsingScopeAttribute",Ct="editor.tablePropertiesUsingIdAttributes",ht="editor.tablePropertiesRows",mt="editor.tablePropertiesColumns",ft="editor.tablePropertiesWidth",Rt="editor.tablePropertiesHeight",ut="editor.tablePropertiesPosition",At="editor.tablePropertiesAlignment",yt="editor.tablePropertiesCellSpacing",Tt="editor.tablePropertiesCellPadding",St="editor.tablePropertiesTableBackground",Bt="editor.tablePropertiesBorderWidth",It="editor.tablePropertiesBorderColor",wt="editor.tablePropertiesBorderStyle",Ht="editor.tablePropertiesCollapseBorders",kt="editor.tablePropertiesID",vt="editor.tablePropertiesCssClass",Wt="editor.tablePropertiesAccessibility",Lt="editor.tablePropertiesCaption",Ft="editor.tablePropertiesCaptionPosition",Mt="editor.tablePropertiesCaptionAlignment",xt="editor.tablePropertiesHeaderRows",Dt="editor.tablePropertiesHeaderCols",Nt="editor.tablePropertiesAssociateHeaders",Ut="editor.tablePropertiesGeneral",Et="editor.tablePropertiesAdvanced",Gt="editor.tablePropertiesSave",Ot="editor.tablePropertiesCancel",zt="editor.borderStyleNone",Jt="editor.borderStyleSolid",Vt="editor.borderStyleDotted",jt="editor.borderStyleDashed",qt="editor.borderStyleDouble",Kt="editor.borderStyleGroove",Qt="editor.borderStyleRidge",Xt="editor.borderStyleInset",Yt="editor.borderStyleOutset",Zt="editor.borderStyleInitial",_t="editor.borderStyleInherit",$t="editor.borderStyleHidden",eo="editor.sizeAuto",to={[e]:"Bold",[t]:"Italic",[o]:"Underline",[r]:"Strikethrough",[i]:"Subscript",[l]:"Superscript",[X]:"Remove hyperlink",[Y]:"Undo",[Z]:"Redo",[_]:"Font Size",[$]:"Font Name",[ee]:"Format",[te]:"Align text left",[oe]:"Align text right",[re]:"Center text",[ie]:"Justify",[le]:"Indent",[se]:"Outdent",[ne]:"Insert ordered list",[de]:"Insert unordered list",[d]:"Print",[c]:"Select All",[a]:"Clean formatting",[p]:"Export as PDF",[b]:"Color",[P]:"Background color",[g]:"Create a table",[C]:"Create a {0} x {1} table",[h]:"Add row above",[m]:"Add row below",[f]:"Add column on the left",[R]:"Add column on the right",[u]:"Delete row",[A]:"Delete column",[y]:"Delete table",[T]:"Merge cells",[S]:"Split cell",[s]:"Insert hyperlink",[B]:"Insert hyperlink",[I]:"Web address",[w]:"Title",[H]:"Open link in new window",[k]:"Cancel",[v]:"Insert",[n]:"Insert file",[W]:"Insert file",[L]:"Web address",[F]:"Title",[M]:"Cancel",[x]:"Insert",[D]:"Insert image",[N]:"Insert image",[U]:"Web address",[E]:"Title",[G]:"Alternate text",[O]:"Width (px)",[z]:"Height (px)",[J]:"Cancel",[V]:"Insert",[j]:"View HTML",[q]:"View HTML",[K]:"Cancel",[Q]:"Update",[ce]:"Find and Replace",[ae]:"Find and Replace",[pe]:"Find",[be]:"Replace",[Pe]:"Find What:",[ge]:"Replace With",[Ce]:"Replace",[he]:"Replace All",[me]:"Match Case",[fe]:"Match whole word only",[Re]:"Match cyclic (Wrap around)",[ue]:"Regular Expression",[Ae]:"Prev",[ye]:"Next",[Te]:"{0} of {1} matches",[Se]:"Invalid regular expression.",[Be]:"Editable area. Press Alt + F10 for toolbar.",[Ie]:"Fore Color",[we]:"Back Color",[He]:"Cell properties",[ke]:"Left Top",[ve]:"Center Top",[We]:"Right Top",[Le]:"Left Middle",[Fe]:"Center Middle",[Me]:"Right Middle",[xe]:"Left Bottom",[De]:"Center Bottom",[Ne]:"Right Bottom",[Ue]:"No Alignment",[Ee]:"Wrap",[Ge]:"Fit to cell",[Oe]:"Apply to all cells",[ze]:"Width",[Je]:"apply to column",[Ve]:"Height",[je]:"apply to row",[qe]:"Alignment",[Ke]:"Text control",[Qe]:"Cell padding",[Xe]:"Background",[Ye]:"Border width",[Ze]:"Border color",[_e]:"Border style",[$e]:"ID",[et]:"CSS class",[tt]:"Save",[ot]:"Cancel",[rt]:"Table properties",[it]:"Align Left",[lt]:"Align Center",[st]:"Align Right",[nt]:"No Alignment",[dt]:"Left",[ct]:"Center",[at]:"Right",[pt]:"Top",[bt]:"Bottom",[Pt]:"None",[gt]:"Using 'scope' attribute",[Ct]:"Using 'id' attributes",[ht]:"Rows",[mt]:"Columns",[ft]:"Width",[Rt]:"Height",[ut]:"Position",[At]:"Alignment",[yt]:"Cell spacing",[Tt]:"Cell padding",[St]:"Table background",[Bt]:"Border width",[It]:"Border color",[wt]:"Border style",[Ht]:"Collapse borders",[kt]:"ID",[vt]:"CSS class",[Wt]:"Accessibility",[Lt]:"Caption",[Ft]:"Position",[Mt]:"Alignment",[xt]:"Header rows",[Dt]:"Header cols",[Nt]:"Associate headers",[Ut]:"General",[Et]:"Advanced",[Gt]:"Save",[Ot]:"Cancel",[zt]:"None",[Jt]:"Solid",[Vt]:"Dotted",[jt]:"Dashed",[qt]:"Double",[Kt]:"Groove",[Qt]:"Ridge",[Xt]:"Inset",[Yt]:"Outset",[Zt]:"Initial",[_t]:"Inherit",[$t]:"Hidden",[eo]:"Auto"},oo={bold:e,italic:t,underline:o,strikethrough:r,subscript:i,superscript:l,unlink:X,undo:Y,redo:Z,fontSize:_,fontName:$,format:ee,alignLeft:te,alignRight:oe,alignCenter:re,alignJustify:ie,indent:le,outdent:se,orderedList:ne,bulletList:de,print:d,selectAll:c,cleanFormatting:a,pdf:p,foregroundColor:b,backgroundColor:P,createTable:g,createTableHint:C,addRowBefore:h,addRowAfter:m,addColumnBefore:f,addColumnAfter:R,deleteRow:u,deleteColumn:A,deleteTable:y,mergeCells:T,splitCell:S,insertHyperlink:s,insertHyperlinkDialogTitle:B,insertHyperlinkAddress:I,insertHyperlinkTitle:w,insertHyperlinkNewWindow:H,insertHyperlinkCancel:k,insertHyperlinkInsert:v,insertFile:n,insertFileDialogTitle:W,insertFileAddress:L,insertFileTitle:F,insertFileCancel:M,insertFileInsert:x,insertImage:D,insertImageDialogTitle:N,insertImageAddress:U,insertImageTitle:E,insertImageAltText:G,insertImageWidth:O,insertImageHeight:z,insertImageCancel:J,insertImageInsert:V,viewHtml:j,viewHtmlDialogTitle:q,viewHtmlCancel:K,viewHtmlUpdate:Q,findReplaceToolTitle:ce,findReplaceDialogTitle:ae,findReplaceTabFind:pe,findReplaceTabReplace:be,findReplaceFindWhat:Pe,findReplaceReplaceWith:ge,findReplaceReplace:Ce,findReplaceReplaceAll:he,findReplaceMatchCase:me,findReplaceMatchWord:fe,findReplaceMatchCyclic:Re,findReplaceUseRegExp:ue,findReplacePrevMatch:Ae,findReplaceNextMatch:ye,findReplaceMatches:Te,findReplaceInvalidRegExp:Se,iframeTitle:Be,foreColorLabel:Ie,backColorLabel:we,cellProperties:He,cellPropertiesLeftTop:ke,cellPropertiesCenterTop:ve,cellPropertiesRightTop:We,cellPropertiesLeftMiddle:Le,cellPropertiesCenterMiddle:Fe,cellPropertiesRightMiddle:Me,cellPropertiesLeftBottom:xe,cellPropertiesCenterBottom:De,cellPropertiesRightBottom:Ne,cellPropertiesNoAlignment:Ue,cellPropertiesWrap:Ee,cellPropertiesFitToCell:Ge,cellPropertiesApplyToAllCells:Oe,cellPropertiesWidth:ze,cellPropertiesApplyToColumn:Je,cellPropertiesHeight:Ve,cellPropertiesApplyToRow:je,cellPropertiesAlignment:qe,cellPropertiesTextControl:Ke,cellPropertiesCellPadding:Qe,cellPropertiesBackground:Xe,cellPropertiesBorderWidth:Ye,cellPropertiesBorderColor:Ze,cellPropertiesBorderStyle:_e,cellPropertiesId:$e,cellPropertiesCssClass:et,cellPropertiesSave:tt,cellPropertiesCancel:ot,tableProperties:rt,tablePropertiesAlignLeft:it,tablePropertiesAlignCenter:lt,tablePropertiesAlignRight:st,tablePropertiesNoAlignment:nt,tablePropertiesLeft:dt,tablePropertiesCenter:ct,tablePropertiesRight:at,tablePropertiesTop:pt,tablePropertiesBottom:bt,tablePropertiesNone:Pt,tablePropertiesUsingScopeAttribute:gt,tablePropertiesUsingIdAttributes:Ct,tablePropertiesRows:ht,tablePropertiesColumns:mt,tablePropertiesWidth:ft,tablePropertiesHeight:Rt,tablePropertiesPosition:ut,tablePropertiesAlignment:At,tablePropertiesCellSpacing:yt,tablePropertiesCellPadding:Tt,tablePropertiesTableBackground:St,tablePropertiesBorderWidth:Bt,tablePropertiesBorderColor:It,tablePropertiesBorderStyle:wt,tablePropertiesCollapseBorders:Ht,tablePropertiesId:kt,tablePropertiesCssClass:vt,tablePropertiesAccessibility:Wt,tablePropertiesCaption:Lt,tablePropertiesCaptionPosition:Ft,tablePropertiesCaptionAlignment:Mt,tablePropertiesHeaderRows:xt,tablePropertiesHeaderCols:Dt,tablePropertiesAssociateHeaders:Nt,tablePropertiesGeneral:Ut,tablePropertiesAdvanced:Et,tablePropertiesSave:Gt,tablePropertiesCancel:Ot,borderStyleNone:zt,borderStyleSolid:Jt,borderStyleDotted:Vt,borderStyleDashed:jt,borderStyleDouble:qt,borderStyleGroove:Kt,borderStyleRidge:Qt,borderStyleInset:Xt,borderStyleOutset:Yt,borderStyleInitial:Zt,borderStyleInherit:_t,borderStyleHidden:$t,sizeAuto:eo};exports.keys=oo;exports.messages=to;
