/**
 * @license
 *-------------------------------------------------------------------------------------------
 * Copyright © 2025 Progress Software Corporation. All rights reserved.
 * Licensed under commercial license. See LICENSE.md in the package root for more information
 *-------------------------------------------------------------------------------------------
 */
"use strict";Object.defineProperty(exports,Symbol.toStringTag,{value:"Module"});const me=require("react"),n=require("../config/toolsSettings.js"),fe=require("./insertTable/tool.js"),pe=require("./insertTable/popup.js"),Ie=require("./align.js"),be=require("./fontStyle.js"),B=require("./applyColor.js"),Ae=require("./formatBlock.js"),U=require("./history.js"),Ce=require("./indent.js"),xe=require("./inlineFormat.js"),we=require("./insertImage.js"),Le=require("./insertLink.js"),Re=require("./lists.js"),ye=require("./outdent.js"),r=require("./tableEdit.js"),ke=require("./unlink.js"),qe=require("./viewHtml.js"),De=require("./print.js"),Ne=require("./pdf.js"),Fe=require("./selectAll.js"),Be=require("./cleanFormatting.js"),Ue=require("./findReplace.js"),O=require("./lists-styled.js"),l=require("@progress/kendo-svg-icons"),Oe=require("./table-wizard/tableCellProperties.js"),Pe=require("./table-wizard/tableProperties.js");function ve(t){const o=Object.create(null,{[Symbol.toStringTag]:{value:"Module"}});if(t){for(const c in t)if(c!=="default"){const a=Object.getOwnPropertyDescriptor(t,c);Object.defineProperty(o,c,a.get?a:{enumerable:!0,get:()=>t[c]})}}return o.default=t,Object.freeze(o)}const s=ve(me);exports.EditorTools=void 0;(t=>{function o(e){return Ie.createAlignTool(e)}t.createAlignTool=o;class c extends o(n.EditorToolsSettings.alignLeft){}t.AlignLeft=c;class a extends o(n.EditorToolsSettings.alignRight){}t.AlignRight=a;class P extends o(n.EditorToolsSettings.alignCenter){}t.AlignCenter=P;class v extends o(n.EditorToolsSettings.alignJustify){}t.AlignJustify=v;function T(e){return fe.InsertTableToolNS.createInsertTableTool(e)}t.createInsertTableTool=T;class h extends T(n.EditorToolsSettings.insertTable){}t.InsertTable=h;class H extends pe.InsertTablePopupNS.InsertTablePopup{}t.InsertTablePopup=H;function d(e){return be.FontStyleToolNS.createStyleDropDownList(e)}t.createStyleDropDownList=d;class M extends d(n.EditorToolsSettings.fontSize){}t.FontSize=M;class V extends d(n.EditorToolsSettings.fontName){}t.FontName=V,t.ForeColor=e=>s.createElement(B.ApplyColorTool,{...n.EditorToolsSettings.foreColor,...e}),t.BackColor=e=>s.createElement(B.ApplyColorTool,{...n.EditorToolsSettings.backColor,...e});function m(e){return Ae.FormatBlockToolNS.createFormatBlockDropDownList(e)}t.createFormatBlockDropDownList=m;class j extends m(n.EditorToolsSettings.formatBlock){}t.FormatBlock=j;function f(e){return U.HistoryToolNS.createUndoTool(e)}t.createUndoTool=f;function p(e){return U.HistoryToolNS.createRedoTool(e)}t.createRedoTool=p;class z extends f(n.EditorToolsSettings.undo){}t.Undo=z;class J extends p(n.EditorToolsSettings.redo){}t.Redo=J;function I(e){return Ce.IndentToolNS.createIndentTool(e)}t.createIndentTool=I;class _ extends I(n.EditorToolsSettings.indent){}t.Indent=_;function i(e){return xe.InlineFormatToolNS.createInlineFormatTool(e)}t.createInlineFormatTool=i;class K extends i(n.EditorToolsSettings.bold){}t.Bold=K;class G extends i(n.EditorToolsSettings.italic){}t.Italic=G;class Q extends i(n.EditorToolsSettings.underline){}t.Underline=Q;class W extends i(n.EditorToolsSettings.strikethrough){}t.Strikethrough=W;class X extends i(n.EditorToolsSettings.subscript){}t.Subscript=X;class Y extends i(n.EditorToolsSettings.superscript){}t.Superscript=Y;function b(e){return we.createInsertImageTool(e)}t.createInsertImageTool=b;class Z extends b(n.EditorToolsSettings.image){}t.InsertImage=Z;function u(e){return Le.LinkToolNS.createLinkTool(e)}t.createLinkTool=u;class $ extends u(n.EditorToolsSettings.link){}t.Link=$;class E extends u(n.EditorToolsSettings.insertFile){}t.InsertFile=E;function g(e){return Re.ListToolNS.createListTool(e)}t.createListTool=g;class ee extends g(n.EditorToolsSettings.orderedList){}t.OrderedList=ee;class te extends g(n.EditorToolsSettings.bulletList){}t.UnorderedList=te,t.BulletedList=e=>{const S=[{icon:"list-unordered",svgIcon:l.listUnorderedIcon,text:"Disc",style:"disc"},{icon:"list-unordered-outline",svgIcon:l.listUnorderedOutlineIcon,text:"Circle",style:"circle"},{icon:"list-unordered-square",svgIcon:l.listUnorderedSquareIcon,text:"Square",style:"square"}];return s.createElement(O.ListTool,{listType:n.EditorToolsSettings.bulletList.listType,items:S,icon:"list-unordered",svgIcon:l.listUnorderedIcon,titleKey:n.EditorToolsSettings.bulletList.messages.title,...e})},t.NumberedList=e=>{const S=[{icon:"list-ordered",svgIcon:l.listOrderedIcon,text:"Decimal"},{icon:"list-roman-upper",svgIcon:l.listRomanUpperIcon,text:"Upper roman",style:"upper-roman"},{icon:"list-roman-lower",svgIcon:l.listRomanLowerIcon,text:"Lower roman",style:"lower-roman"},{icon:"list-latin-big",svgIcon:l.listLatinBigIcon,text:"Upper latin",style:"upper-latin"},{icon:"list-latin-small",svgIcon:l.listLatinSmallIcon,text:"Lower latin",style:"lower-latin"}];return s.createElement(O.ListTool,{listType:n.EditorToolsSettings.orderedList.listType,items:S,icon:"list-ordered",svgIcon:l.listOrderedIcon,titleKey:n.EditorToolsSettings.orderedList.messages.title,...e})},t.TableCellProperties=Oe.TableCellProperties,t.TableProperties=Pe.TableProperties;function A(e){return ye.OutdentToolNS.createOutdentTool(e)}t.createOutdentTool=A;class ne extends A(n.EditorToolsSettings.outdent){}t.Outdent=ne,t.Print=e=>s.createElement(De.Print,{...e}),t.Pdf=e=>s.createElement(Ne.Pdf,{...e}),t.SelectAll=e=>s.createElement(Fe.SelectAll,{...e}),t.CleanFormatting=e=>s.createElement(Be.CleanFormatting,{...e});function C(e){return r.TableEditNS.createAddRowBeforeTool(e)}t.createAddRowBeforeTool=C;function x(e){return r.TableEditNS.createAddRowAfterTool(e)}t.createAddRowAfterTool=x;function w(e){return r.TableEditNS.createAddColumnBeforeTool(e)}t.createAddColumnBeforeTool=w;function L(e){return r.TableEditNS.createAddColumnAfterTool(e)}t.createAddColumnAfterTool=L;function R(e){return r.TableEditNS.createDeleteRowTool(e)}t.createDeleteRowTool=R;function y(e){return r.TableEditNS.createDeleteColumnTool(e)}t.createDeleteColumnTool=y;function k(e){return r.TableEditNS.createDeleteTableTool(e)}t.createDeleteTableTool=k;function q(e){return r.TableEditNS.createMergeCellsTool(e)}t.createMergeCellsTool=q;function D(e){return r.TableEditNS.createSplitCellTool(e)}t.createSplitCellTool=D;class le extends C(n.EditorToolsSettings.addRowBefore){}t.AddRowBefore=le;class oe extends x(n.EditorToolsSettings.addRowAfter){}t.AddRowAfter=oe;class re extends w(n.EditorToolsSettings.addColumnBefore){}t.AddColumnBefore=re;class se extends L(n.EditorToolsSettings.addColumnAfter){}t.AddColumnAfter=se;class ie extends R(n.EditorToolsSettings.deleteRow){}t.DeleteRow=ie;class ce extends y(n.EditorToolsSettings.deleteColumn){}t.DeleteColumn=ce;class ae extends k(n.EditorToolsSettings.deleteTable){}t.DeleteTable=ae;class de extends q(n.EditorToolsSettings.mergeCells){}t.MergeCells=de;class ue extends D(n.EditorToolsSettings.splitCell){}t.SplitCell=ue;function N(e){return ke.UnlinkToolNS.createUnlinkTool(e)}t.createUnlinkTool=N;class ge extends N(n.EditorToolsSettings.unlink){}t.Unlink=ge;function F(e){return qe.ViewHtmlToolNS.createViewHtmlTool(e)}t.createViewHtmlTool=F;class Se extends F(n.EditorToolsSettings.viewHtml){}t.ViewHtml=Se;class Te extends Ue.FindAndReplace{}t.FindAndReplace=Te})(exports.EditorTools||(exports.EditorTools={}));
